<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/


if (eregi("block-Sommaire.php", $_SERVER['PHP_SELF'])) {
    Header("Location: index.php");
    die();
}


global $prefix, $db, $admin;

    $ThemeSel = get_theme();
    if (file_exists("themes/$ThemeSel/module.php")) {
	include("themes/$ThemeSel/module.php");
	if (is_active("$default_module") AND file_exists("modules/$default_module/index.php")) {
	    $def_module = $default_module;
	} else {
	    $def_module = "";
	}
    }

    $sql = "SELECT main_module FROM ".$prefix."_main";
    $result = $db->sql_query($sql);
    $row = $db->sql_fetchrow($result);
    $main_module = $row[main_module];

/************************************************************************************/
/*					Modifications par marcoledingue - 29/06/2003 					*/
/*								marcoledingue@free.fr								*/
/*											v.2.0									*/
/* Permet d'afficher le sommaire du site (liste des modules) avec des catgories,	*/
/* de choisir l'ordre d'affichage des modules et de choisir des urls externes. 		*/
/* Affiche une image (mail) si des Messages Privs ne sont pas lus.					*/
/* 																					*/
/* Ces modifications ncessitent 2 tables, nomme nuke_sommaire et 					*/
/* nuke_sommaire_categories (cf install.txt)										*/
/* 																					*/
/************************************************************************************/

// Ce test a t enlev car ca fait 1 requte sql pour rien...
// les modules effacs sont automatiquement effacs de la BDD quand on visite la page d'administration des modules.
    /* If the module doesn't exist, it will be removed from the database automaticaly */
/*
    $sql = "SELECT title FROM ".$prefix."_modules";
    $result = $db->sql_query($sql);
    while ($row = $db->sql_fetchrow($result)) {
	$title = $row[title];
	$a = 0;
	$handle=opendir('modules');
	while ($file = readdir($handle)) {
    	    if ($file == $title) {
		$a = 1;
	    }
	}
	closedir($handle);
	if ($a == 0) {
	    $db->sql_query("DELETE FROM ".$prefix."_modules WHERE title='$title'");
	}
    }
*/

$content .="<!-- Sommaire realise grace au module Sommaire Parametrable v.2.0 - marcoledingue - marcoledingue@free.fr -->";
// on rcupre les infos pour savoir si le user a des messages privs non lus //
global $user, $cookie, $user_prefix, $def_module;
	cookiedecode($user);
	$username = $cookie[1];
 	$sql = "SELECT user_id FROM $user_prefix"._users." WHERE username='$username'";
 	$result = $db->sql_query($sql);
 	$row = $db->sql_fetchrow($result);
 	$uid = $row[user_id];
 	$newpms = $db->sql_fetchrow($db->sql_query("SELECT COUNT(*) FROM $prefix"._bbprivmsgs." WHERE privmsgs_to_userid='$uid' AND (privmsgs_type='5' OR privmsgs_type='1')"));
// voil, si $newpms[0]>0 --> il y a des PMs non lus //

	$flagmenu = 0;  // flag qui est mis automatiquement  "1" quand il y a un module dans la rubrique 99
					// --> permet d'afficher 1 seule fois la barre horizontale.

	$path_icon = "images/sommaire";
	
	// on va mettre les donnes de la table nuke_sommaire_categories dans les variables adquates.
	$sql2= "SELECT groupmenu, module, url, url_text, image FROM ".$prefix."_sommaire_categories ORDER BY id ASC";
	$result2= $db->sql_query($sql2);
	$compteur=0;
	$totalcompteur=0;
	$row2=$db->sql_fetchrow($result2); //on rcupre la premire ligne de la table, et on affecte aux variables.
	$categorie=$row2[groupmenu];
	$moduleinthisgroup[$categorie][$compteur]=$row2[module];
	$linkinthisgroup[$categorie][$compteur]=$row2[url];
	$linktextinthisgroup[$categorie][$compteur]=$row2[url_text];
	$imageinthisgroup[$categorie][$compteur]=$row2[image];
	$totalcategorymodules[$totalcompteur]=$row2[module]; //utile quand groupmenu=99 -->cette variable liste tous les modules affichs dans des catgories
	$compteur2=$categorie;
	$totalcompteur=1;
	//	echo "{$moduleinthisgroup[$categorie][$compteur]}<br>{$linkinthisgroup[$categorie][$compteur]}<br>{$linktextinthisgroup[$categorie][$compteur]}<br>{$imageinthisgroup[$categorie][$compteur]}<br>";
	while ($row2 = $db->sql_fetchrow($result2)) { //ensuite on fait la mme chose pour toutes les autres lignes.
		$categorie=$row2[groupmenu];
		$totalcategorymodules[$totalcompteur]=$row2[module];
		$totalcompteur++;
		
		if ($compteur2==$categorie) { //permet de savoir si on a chang de catgorie (groupmenu diffrent) : dans ce cas on remet le 2me compteur  0.
			$compteur++;
		}
		else {
			$compteur=0;
		}
		$moduleinthisgroup[$categorie][$compteur]=$row2[module];
		$linkinthisgroup[$categorie][$compteur]=$row2[url];
		$linktextinthisgroup[$categorie][$compteur]=$row2[url_text];
		$imageinthisgroup[$categorie][$compteur]=$row2[image];
		$compteur2=$categorie;
	//	echo "{$moduleinthisgroup[$categorie][$compteur]}<br>{$linkinthisgroup[$categorie][$compteur]}<br>{$linktextinthisgroup[$categorie][$compteur]}<br>{$imageinthisgroup[$categorie][$compteur]}<br>";
	}
// --> OK, les variables ont pris la valeur adquate de la table nuke_sommaire_categories

// on va mettre la liste des modules dans la variable $modules
	$sql = "SELECT title, custom_title, view FROM ".$prefix."_modules WHERE active='1' AND title!='$def_module' AND inmenu='1' ORDER BY custom_title ASC";
	$modulesaffiche= $db->sql_query($sql);
	$compteur=0;
	while ($tempo = $db->sql_fetchrow($modulesaffiche)) {
		$module[$compteur]= $tempo[title];
		$customtitle[$compteur] = $tempo[custom_title];
		$view[$compteur] = $tempo[view];
		$compteur++;
	}

	// Ensuite, on charge la table nuke_sommaire //
    $sql = "SELECT groupmenu, name, image, lien, hr, center, bgcolor, invisible, class FROM ".$prefix."_sommaire ORDER BY groupmenu ASC";
    $result = $db->sql_query($sql);
	$content.="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
	$classpointeur=0;
    while ($row = $db->sql_fetchrow($result)) {  // on va afficher chaque catgorie, puis les modules correspondants//
		$som_groupmenu = $row[groupmenu];
		$som_name = ereg_replace("&amp;nbsp;","&nbsp;",$row[name]);
		$som_image = $row[image];
		$som_lien = $row[lien];
		$som_hr = $row[hr];
		$som_center = $row[center];
		$som_bgcolor = $row[bgcolor];
		$invisible[$classpointeur] = $row[invisible];
		$categoryclass[$classpointeur] = $row['class'];
		
		if ($som_hr == "on") {
			$content.="<tr><td><hr></td></tr>";
		}

		if (($som_groupmenu <> 99) AND ($som_name<>"") ) {
			
			$content.="<tr height=\"4\" bgcolor=\"$som_bgcolor\"><td></td></tr>";
			$content.="<tr><td bgcolor=\"$som_bgcolor\" >";
			
			if ($som_center=="on") {
				$content.="<div align=\"center\">";
			}
			if ($som_image<> "noimg") {

/************************************************************************************/
/*                 Modifications par MAC06  17/07/2003                              */
/*                  http://visiondesign.free.fr                                     */
/*                     magetmac06@hotmail.com                                       */
/*  Les modifs permettent d'inserer soit un swf (Flash), soit une image normale.    */
/*  Les images et les swf doivent etre placs dans "images/sommaire/".              */
/*                                                                                  */
/*                                                                                  */
/************************************************************************************/

				if (eregi(".swf",$som_image)) { //////////////////// support des fichiers FLASH - par MAC06 //////////////////////////
					$content .= "<OBJECT classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\"179\" height=\"20\" id=\"$som_groupmenu\"><PARAM NAME=movie VALUE=\"$path_icon/$som_image\"><PARAM NAME=quality VALUE=high><EMBED src=\"$path_icon/$som_image\" quality=high WIDTH=\"160\" HEIGHT=\"20\" TYPE=\"application/x-shockwave-flash\" wmode=\"transparent\"></EMBED></OBJECT><br>";
        		}
				else {
					$content.="<img src=\"$path_icon/$som_image\" border=\"0\">&nbsp;";
				}
			}
			if ($som_lien<>"") {
				$content.="<a href=\"$som_lien\"";
				$testehttp=strpos($som_lien,"http://");
				$testeftp=strpos($som_lien,"ftp://");
				if ($testehttp===0 || $testeftp===0) {
					$content.=" target=\"_blank\"";
				}
				$content.=">";
			}
			 // gestion multilingue : si le nom de catgorie commence par 'LANG:_' alors c'est multilingue, donc on va afficher ce qui a t inscrit dans le fichier de langue.
			if (strpos($som_name,"LANG:_")===0) {
				$som_name = str_replace("LANG:","",$som_name);
				eval( "\$som_name = $som_name;");
			}//fin gestion multilingue
			
			if (!eregi(".swf",$som_image)) { //////////////////// support des fichiers FLASH - par MAC06 //////////////////////////
				$content.="<font class=\"$categoryclass[0]\">$som_name</font><br>";
			}
			
			if ($som_lien<>"") {
			$content.="</a>";
			}
			if ($som_center=="on") {
				$content.="</div>";
			}
			$content.="</td></tr>";
			
		}
		$keyinthisgroup=0;
		
		if ($som_groupmenu<>99) {
		$content.="<tr><td bgcolor=\"$som_bgcolor\">";
		while ($moduleinthisgroup[$som_groupmenu][$keyinthisgroup]) { //on va checker si chaque module indiqu dans la catgorie en cours est install et activ/visible //
		
		if($moduleinthisgroup[$som_groupmenu][$keyinthisgroup]=="Lien externe") {
			if ($imageinthisgroup[$som_groupmenu][$keyinthisgroup]<>"middot.gif") {
				if ($som_image<>"noimg" && !eregi(".swf",$som_image) && $som_center<>"on") { ///////////////////////////support des fichiers FLASH - par MAC06 /////////////////////////
					$catimagesize = getimagesize("$path_icon/$som_image");//l on va rcuprer la largeur de l'image de la catgorie, pour aligner les modules avec le titre de la catgorie.
					$moduleimagesize = getimagesize("$path_icon/categories/".$imageinthisgroup[$som_groupmenu][$keyinthisgroup]."");
					$imagesize =$catimagesize[0]-$moduleimagesize[0];
					if ($imagesize<0) {
						$imagesize=0;
					}
				}
				else {
					$imagesize=0;
				}
				$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><img src=\"$path_icon/categories/".$imageinthisgroup[$som_groupmenu][$keyinthisgroup]."\">&nbsp;<a href=\"".$linkinthisgroup[$som_groupmenu][$keyinthisgroup]."\"";
				
				$testehttp=strpos($linkinthisgroup[$som_groupmenu][$keyinthisgroup],"http://");
				$testeftp=strpos($linkinthisgroup[$som_groupmenu][$keyinthisgroup],"ftp://");
				if ($testehttp===0 || $testeftp===0) {
					$content.=" target=\"_blank\"";
				}
				// gestion multilingue : si le texte du lien commence par 'LANG:_' alors c'est multilingue, donc on va afficher ce qui a t inscrit dans le fichier de langue.
				$linklang=$linktextinthisgroup[$som_groupmenu][$keyinthisgroup];
				if (strpos($linklang,"LANG:_")===0) {
					$linklang = str_replace("LANG:","",$linklang);
					eval( "\$linklang = $linklang;");
					$linktextinthisgroup[$som_groupmenu][$keyinthisgroup]=$linklang;
				}//fin gestion multilingue
				
				$content.=">".$linktextinthisgroup[$som_groupmenu][$keyinthisgroup]."</a><br>";
			}
			else {
				if ($som_image<>"noimg" &&!eregi(".swf",$som_image) && $som_center<>"on") {  ///////////////////////////support des fichiers FLASH - par MAC06 /////////////////////////
					$catimagesize = getimagesize("$path_icon/$som_image");
					$imagesize=$catimagesize[0]-5;
				}
				else {
					$imagesize=0;
				}
				$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><strong><big>&middot;&nbsp;</strong></big><a href=\"".$linkinthisgroup[$som_groupmenu][$keyinthisgroup]."\"";
				$testehttp=strpos($linkinthisgroup[$som_groupmenu][$keyinthisgroup],"http://");
				$testeftp=strpos($linkinthisgroup[$som_groupmenu][$keyinthisgroup],"ftp://");
				if ($testehttp===0 || $testeftp===0) {
					$content.=" target=\"_blank\"";
				}
			// gestion multilingue : si le texte du lien commence par 'LANG:_' alors c'est multilingue, donc on va afficher ce qui a t inscrit dans le fichier de langue.
			$linklang=$linktextinthisgroup[$som_groupmenu][$keyinthisgroup];
			if (strpos($linklang,"LANG:_")===0) {
				$linklang = str_replace("LANG:","",$linklang);
				eval( "\$linklang = $linklang;");
				$linktextinthisgroup[$som_groupmenu][$keyinthisgroup]=$linklang;
			}//fin gestion multilingue
			$content.=">".$linktextinthisgroup[$som_groupmenu][$keyinthisgroup]."</a><br>";
			}
		}
		
		for ($z=0;$z<count($module);$z++) { //pour chaque module activ et visible on va regarder o on l'affiche
			$customtitle2 = ereg_replace("_", " ", $module[$z]);
			if ($customtitle[$z] != "") {
			    $customtitle2 = $customtitle[$z];
			}
			if ($module[$z] != $main_module) {
	    		if ((is_admin($admin) AND $view[$z] == 2) OR $view[$z] != 2) { //si on n'est pas admin et que le module est rserv aux admins, il n'apparat pas
					if ($moduleinthisgroup[$som_groupmenu][$keyinthisgroup]==$module[$z]) {
						if ($imageinthisgroup[$som_groupmenu][$keyinthisgroup]<>"middot.gif") {
							
							if ($som_image<>"noimg" &&!eregi(".swf",$som_image) && $som_center<>"on") { ///////////////////////////support des fichiers FLASH - par MAC06 /////////////////////////
								$catimagesize = getimagesize("$path_icon/$som_image");
								$moduleimagesize = getimagesize("$path_icon/categories/".$imageinthisgroup[$som_groupmenu][$keyinthisgroup]."");
								$imagesize =$catimagesize[0]-$moduleimagesize[0];
								if ($imagesize<0) {
									$imagesize=0;
								}
							}
							else {
								$imagesize=0;
							}
							if (!is_user($user) AND $view[$z]==1) { //permet d'afficher ou non le module selon l'option indique dans l'admin
								if ($invisible[0]==1) {
									$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><img src=\"$path_icon/categories/".$imageinthisgroup[$som_groupmenu][$keyinthisgroup]."\">&nbsp;";
								}
								elseif ($invisible[0]==2) {
									$imagesize=$catimagesize[0]-10;
									if ($imagesize<0) {$imagesize=0;}
									$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><img src=\"images/sommaire/admin/interdit.gif\" alt=\"Accs rserv aux membres\" title=\"Accs rserv aux membres\">&nbsp;";
								}
								elseif ($invisible[0]==3) {
								}
							}
							else {
								$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><img src=\"$path_icon/categories/".$imageinthisgroup[$som_groupmenu][$keyinthisgroup]."\">&nbsp;";
							}
						}
						else {
							if ($som_image<>"noimg" &&!eregi(".swf",$som_image) && $som_center<>"on") { ///////////////////////////support des fichiers FLASH - par MAC06 /////////////////////////
								$catimagesize = getimagesize("$path_icon/$som_image");
								$imagesize=$catimagesize[0]-5;
							}
							else {
								$imagesize=0;
							}
							if (!is_user($user) AND $view[$z]==1) { //permet d'afficher ou non le module selon l'option indique dans l'admin
								if ($invisible[0]==1) {
									$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><strong><big>&middot;&nbsp;</strong></big>";
								}
								elseif ($invisible[0]==2) {
									$imagesize=$catimagesize[0]-10;
									if ($imagesize<0) {$imagesize=0;}
									$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><img src=\"images/sommaire/admin/interdit.gif\" alt=\"Accs rserv aux membres\" title=\"Accs rserv aux membres\">&nbsp;";
								}
								elseif ($invisible[0]==3) {
								}
							}
							else {
								$content.="<img src=\"$path_icon/admin/none.gif\" width=\"$imagesize\" height=\"1\"><strong><big>&middot;&nbsp;</strong></big>";
							}
						}
						if (($newpms[0]) AND ($module[$z] =="Private_Messages")) {
						$content.="<img src=\"images/blocks/email-y.gif\" height=\"10\" width=\"14\" alt=\"Nouveaux messages privs !!\" title=\"Nouveaux messages privs !!\">";
						}
						
						if (!is_user($user) AND $view[$z]==1 AND $invisible[0]==3) { //permet d'afficher ou non le module selon l'option indique dans l'admin
						}
						else {
							$content.="<a href=\"modules.php?name=$module[$z]\">$customtitle2</a><br>";
						}
					}
					
				}
			}
		}// end for
   		$keyinthisgroup++;
		}// end while
		$content.="</td></tr>";
		$content.="<tr height=\"4\" bgcolor=\"$som_bgcolor\"><td></td></tr>";
		}//end if somgroupmenu<>99
		
	if ($som_groupmenu == 99) { // si on est  la catgorie 99, on affiche tous les modules installs/activs/visibles qui n'ont pas t affichs dans les catgories.
		$content.="<tr><td>";

		for ($z=0;$z<count($module);$z++) {
			$customtitle2 = ereg_replace ("_"," ", $module[$z]);
			if ($customtitle[$z] != "") {
				$customtitle2 = $customtitle[$z];
			}
			if ($module[$z] != $main_module) {
 				if ((is_admin($admin) AND $view[$z] == 2) OR $view[$z] != 2) {
					
					$incategories=0;
					for ($i=0;$i<count($totalcategorymodules);$i++) {
						if ($module[$z]==$totalcategorymodules[$i]) {
							$incategories=1;
						}
					}
					if ($incategories==0) {
						$flagmenu = $flagmenu+1;
						if ($flagmenu==1) {
							$content .="<hr>";   // si il y a des modules affichs en rubrique 99, on affiche avant une ligne horizontale
						}
						if (($newpms[0]) AND ($module[$z]=="Private_Messages")) { // si PMs non lus, on affiche le logo mail
				 			$content .= "<strong><big>&middot;</strong></big><img src=\"images/blocks/email-y.gif\" height=\"10\" width=\"14\" alt=\"Nouveaux messages privs !!\" title=\"Nouveaux messages privs !!\"><a href=\"modules.php?name=$module[$z]\">$customtitle2</a><br>\n";
						}
						else {
							$content .= "<strong><big>&middot;&nbsp;</strong></big><a href=\"modules.php?name=$module[$z]\">$customtitle2</a><br>\n";
						}
					}
				}
			}
		}//end for groupmenu=99
		$content.="</td></tr>";
	}//end if groupmenu=99
	}
	$content.="</table>";
////// Fin des modifications marcoledingue /////


/* Now we make the Modules block with the correspondent links */
/*
    $content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"index.php\">"._HOME."</a><br>\n";
    $sql = "SELECT title, custom_title, view FROM ".$prefix."_modules WHERE active='1' AND title!='$def_module' AND inmenu='1' ORDER BY custom_title ASC";
    $result = $db->sql_query($sql);
    while ($row = $db->sql_fetchrow($result)) {
	$m_title = $row[title];
	$custom_title = $row[custom_title];
	$view = $row[view];
	$m_title2 = ereg_replace("_", " ", $m_title);
	if ($custom_title != "") {
	    $m_title2 = $custom_title;
	}
	if ($m_title != $main_module) {
	    if ((is_admin($admin) AND $view == 2) OR $view != 2) {
		    $content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?name=$m_title\">$m_title2</a><br>\n";
	}
    }
   }
*/

	    /* If you're Admin you and only you can see Inactive modules and test it */
    /* If you copied a new module is the /modules/ directory, it will be added to the database */

    if (is_admin($admin)) {
	$handle=opendir('modules');
	while ($file = readdir($handle)) {
	    if ( (!ereg("[.]",$file)) ) {
		$modlist .= "$file ";
	    }
	}
	closedir($handle);
	$modlist = explode(" ", $modlist);
	sort($modlist);
	for ($i=0; $i < sizeof($modlist); $i++) {
	    if($modlist[$i] != "") {
		$sql = "SELECT mid FROM ".$prefix."_modules WHERE title='$modlist[$i]'";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$mid = $row[mid];
		if ($mid == "") {
		    $db->sql_query("INSERT INTO ".$prefix."_modules VALUES (NULL, '$modlist[$i]', '$modlist[$i]', '0', '0', '1')");
		}
	    }
	}
	$content .= "<br><center><b>"._INVISIBLEMODULES."</b><br>";
	$content .= "<font class=\"tiny\">"._ACTIVEBUTNOTSEE."</font></center><br>";
	$sql = "SELECT title, custom_title FROM ".$prefix."_modules WHERE active='1' AND inmenu='0' ORDER BY title ASC";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result)) {
	    $mn_title = $row[title];
	    $custom_title = $row[custom_title];
	    $mn_title2 = ereg_replace("_", " ", $mn_title);
	    if ($custom_title != "") {
		$mn_title2 = $custom_title;
	    }
	    if ($mn_title2 != "") {
		$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?name=$mn_title\">$mn_title2</a><br>\n";
		$dummy = 1;
	    } else {
		$a = 1;
	    }
	}
	if ($a == 1 AND $dummy != 1) {
    	    $content .= "<strong><big>&middot;</big></strong>&nbsp;<i>"._NONE."</i><br>\n";
	}
	$content .= "<br><center><b>"._NOACTIVEMODULES."</b><br>";
	$content .= "<font class=\"tiny\">"._FORADMINTESTS."</font></center><br>";
	$sql = "SELECT title, custom_title FROM ".$prefix."_modules WHERE active='0' ORDER BY title ASC";
	$result = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($result)) {
	    $mn_title = $row[title];
	    $custom_title = $row[custom_title];
	    $mn_title2 = ereg_replace("_", " ", $mn_title);
	    if ($custom_title != "") {
	    $mn_title2 = $custom_title;
	    }
	    if ($mn_title2 != "") {
           	$content .= "<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?name=$mn_title\">$mn_title2</a><br>\n";
		$dummy = 1;
	    } else {
		    $a = 1;
            }
	}
	if ($a == 1 AND $dummy != 1) {
    	    $content .= "<strong><big>&middot;</big></strong>&nbsp;<i>"._NONE."</i><br>\n";
	}
    }


?>